import kotlinx.coroutines.delay
import kotlinx.coroutines.runBlocking
import ru.landgrafhomyak.bgtu.networks0.icmp.pinger_IPv4
import ru.landgrafhomyak.bgtu.networks0.low_level.multithreading.Thread
import ru.landgrafhomyak.bgtu.networks0.low_level.sockets.EpollSocketEventLoop

class EventLoopRoutine(private val loop: EpollSocketEventLoop) : Thread.Routine {
	override fun run() {
		while (true) {
			try {
				this.loop.runUntilError()
			} catch (e: Throwable) {
				e.printStackTrace()
				break // todo remove
			}
		}
	}
}

fun main() {
	try {
		EpollSocketEventLoop().use { loop ->
			Thread(EventLoopRoutine(loop)).use { loopThread ->
				loopThread.start()
				loop.pinger_IPv4("8.8.8.8").use { googleSock ->

					runBlocking {
						for (i in 0..10) {
							print("google: ${googleSock.ping(1000u)}ms\n")
							delay(1000)
						}
					}
				}
			}
		}
	} catch (e: Throwable) {
		e.printStackTrace()
	}
}